﻿--[[ some parser stuff to be better compatible with different localizations, 
	credits to ParserLib from Rophy for the nice regexps in the patternconvert code]]--
	
VanasKoS_Parser_MessageMap = {
	-- HEALEDCRITOTHEROTHER:
	--	enUS: "%s 's %s critically heals %s for %d.";
	-- 	deDE: "Kritische Heilung: %2$s heilt %3$s um %4$d Punkte.";
	{
		pattern = HEALEDCRITOTHEROTHER,
		map = {
			["source"] = 1,
			["spell"] = 2,
			["target"] = 3,
			["amount"] = 4,
		},
	},
	-- HEALEDOTHEROTHER: 
	--	enUS: "%s 's %s heals %s for %d."
	{ 
		pattern = HEALEDOTHEROTHER,
		map = {
			["source"] = 1,
			["spell"] = 2,
			["target"] = 3,
			["amount"] = 4,
		},
	},
	-- HEALEDOTHER
	--	enUS: "%s heals %s for %d.";
	{ 
		pattern = HEALEDOTHER,
		map = {
			["source"] = 1,
			["spell"] = nil,
			["target"] = 2,
			["amount"] = 3,
		},
	},
	-- SPELLDEFLECTEDOTHEROTHER
	--	enUS: "%s 's %s was deflected by %s.";
	{
		pattern = SPELLDEFLECTEDOTHEROTHER,
		map = {
			["source"] = 1,
			["spell"] = 2,
			["target"] = 3,
			["amount"] = nil,
		},
	},
	-- SPELLPARRIEDOTHEROTHER
	--		enUS: "%s 's %s was parried by %s.";
	{
		pattern = SPELLPARRIEDOTHEROTHER,
		map = {
			["source"] = 1,
			["spell"] = 2,
			["target"] = 3,
			["amount"] = nil,
		},
	},
	-- SPELLDODGEDOTHEROTHER 
	-- 	enUS: "%s 's %s was dodged by %s.";
	{
		pattern = SPELLDODGEDOTHEROTHER,
		map = {
			["source"] = 1,
			["spell"] = 2,
			["target"] = 3,
			["amount"] = nil,
		},
	},
	-- SPELLPOWERDRAINOTHEROTHER
	-- 	enUS: "%s 's %s drains %d %s from %s.";
	{
		pattern = SPELLPOWERDRAINOTHEROTHER,
		map = {
			["source"] = 1,
			["spell"] = 2,
			["target"] = 5,
			["amount"] = 3,
		},
	},
	-- SPELLLOGCRITOTHEROTHER
	--	enUS: "%s 's %s crits %s for %d.";
	{
		pattern = SPELLLOGCRITOTHEROTHER,
		map = {
			["source"] = 1,
			["spell"] = 2,
			["target"] = 3,
			["amount"] = 4,
		},
	},
	-- SPELLLOGOTHEROTHER
	--	enUS: "%s 's %s hits %s for %d.";
	{
		pattern = SPELLLOGOTHEROTHER,
		map = {
			["source"] = 1,
			["spell"] = 2,
			["target"] = 3,
			["amount"] = 4,
		},
	},
	-- COMBATHITOTHEROTHER
	--	enUS: "%s hits %s for %d.";
	{
		pattern = COMBATHITOTHEROTHER,
		map = {
			["source"] = 1,
			["spell"] = nil,
			["target"] = 2,
			["amount"] = 3,
		},
	},
	-- COMBATHITCRITOTHEROTHER
	--	enUS: "%s crits %s for %d.";
	{
		pattern = COMBATHITCRITOTHEROTHER,
		map = {
			["source"] = 1,
			["spell"] = nil,
			["target"] = 2,
			["amount"] = 3,
		},
	},
	-- SPELLRESISTOTHEROTHER
	--	enUS: "%s's %s was resisted by %s.";
	{
		pattern = SPELLRESISTOTHEROTHER,
		map = {
			["source"] = 1,
			["spell"] = 2,
			["target"] = 3,
			["amount"] = nil,
		},
	},
	-- SPELLRESISTOTHER
	--	enUS: "%s was resisted by %s.";
	{
		pattern = SPELLRESISTOTHER,
		map = {
			["source"] = 1,
			["spell"] = nil,
			["target"] = 2,
			["amount"] = nil,
		},
	},
	-- IMMUNEDAMAGECLASSOTHEROTHER
	--	enUS: "%s is immune to %s's %s damage.";
	{
		pattern = IMMUNEDAMAGECLASSOTHEROTHER,
		map = {
			["source"] = 1,
			["spell"] = 3,
			["target"] = 2,
			["amount"] = nil,
		},
	},
	-- SPELLCASTGOOTHERTARGETTED
	--	enUS: "%s casts %s on %s.";
	{
		pattern = SPELLCASTGOOTHERTARGETTED,
		map = {
			["source"] = 1,
			["spell"] = 2,
			["target"] = 3,
			["amount"] = nil,
		},
	},
	-- SPELLCASTGOOTHER
	-- 	enUS: "%s casts %s.";
	{
		pattern = SPELLCASTGOOTHER,
		map = {
			["source"] = 1,
			["spell"] = 2,
			["target"] = nil,
			["amount"] = nil,
		},
	},
	-- AURAADDEDOTHERHARMFUL
	--	enUS: "%s is afflicted by %s.";
	{
		pattern = AURAADDEDOTHERHARMFUL,
		map = {
			["source"] = 1,
			["spell"] = 2,
			["target"] = nil,
			["amount"] = nil,
		},
	},
	-- PERIODICAURAHEALOTHEROTHER
	--	enUS: "%s gains %d health from %s 's %s.";
	{
		pattern = PERIODICAURAHEALOTHEROTHER,
		map = {
			["source"] = 1,
			["spell"] = 4,
			["target"] = 3,
			["amount"] = 2,
		},
	},
	-- PERIODICAURAHEALSELFOTHER
	--	enUS: "%s gains %d health from your %s.";
	{
		pattern = PERIODICAURAHEALSELFOTHER,
		map = {
			["source"] = 1,
			["spell"] = 4,
			["target"] = nil,
			["amount"] = 2,
		},
	},
	-- POWERGAINOTHEROTHER
	--	enUS: "%s gains %d %s from %s 's %s.";
	{
		pattern = POWERGAINOTHEROTHER,
		map = {
			["source"] = 1,
			["spell"] = 5,
			["target"] = 4,
			["amount"] = 2,
		},
	},
	-- POWERGAINOTHER
	--	enUS: "%s gains %d %s from %s.";
	{
		pattern = POWERGAINOTHER,
		map = {
			["source"] = 1,
			["spell"] = 4,
			["target"] = nil,
			["amount"] = 2,
		},
	},
	-- AURAADDEDOTHERHELPFUL
	--	enUS: "%s gains %s."
	{
		pattern = AURAADDEDOTHERHELPFUL,
		map = {
			["source"] = 1,
			["spell"] = 2,
			["target"] = nil,
			["amount"] = nil,
		},
	},
	-- SPELLPERFORMGOOTHER
	--	enUS: "%s performs %s.";
	{
		pattern = SPELLPERFORMGOOTHER,
		map = {
			["source"] = 1,
			["spell"] = 2,
			["target"] = nil,
			["amount"] = nil,
		},
	},
	-- SPELLPERFORMGOOTHERTARGETTED
	-- 	enUS: "%s performs %s on %s.";
	{
		pattern = SPELLPERFORMGOOTHERTARGETTED,
		map = {
			["source"] = 1,
			["spell"] = 2,
			["target"] = 3,
			["amount"] = nil,
		},
	},
	-- MISSEDOTHEROTHER
	--	enUS: "%s misses %s.";
	{
		pattern = MISSEDOTHEROTHER,
		map = {
			["source"] = 1,
			["spell"] = nil,
			["target"] = 2,
			["amount"] = nil,
		},
	},
	-- PERIODICAURADAMAGEOTHER
	--	enUS: "%s suffers %d %s damage from %s.";
	{
		pattern = PERIODICAURADAMAGEOTHER,
		map = {
			["source"] = nil,
			["spell"] = 4,
			["target"] = 1,
			["amount"] = 2,
		},
	},
	-- PERIODICAURADAMAGEOTHEROTHER
	--	enUS: "%s suffers %d %s damage from %s's %s.";
	{
		pattern = PERIODICAURADAMAGEOTHEROTHER,
		map = {
			["source"] = 4,
			["spell"] = 5,
			["target"] = 1,
			["amount"] = 2,
		},
	},
	-- PERIODICAURADAMAGESELFOTHER
	--	enUS: "%s suffers %d %s damage from your %s.";
	{
		pattern = PERIODICAURADAMAGESELFOTHER,
		map = {
			["source"] = nil,
			["spell"] = 4,
			["target"] = 1,
			["amount"] = 2,
		},
	},
	-- SPELLPERFORMOTHERSTART
	--	enUS: "%s begins to perform %s.";
	{
		pattern = SPELLPERFORMOTHERSTART,
		map = {
			["source"] = 1,
			["spell"] = 2,
			["target"] = nil,
			["amount"] = nil,
		},
	},
	-- SPELLCASTOTHERSTART
	--	enUS: "%s begins to cast %s.";
	{
		pattern = SPELLCASTOTHERSTART,
		map = {
			["source"] = 1,
			["spell"] = 2,
			["target"] = nil,
			["amount"] = nil,
		},
	},
	-- VSDODGEOTHEROTHER
	--	enUS: "%s attacks. %s dodges.";
	{
		pattern = VSDODGEOTHEROTHER,
		map = {
			["source"] = 1,
			["spell"] = nil,
			["target"] = 2,
			["amount"] = nil,
		},
	},
	-- VSABSORBOTHEROTHER
	--	enUS: "%s attacks. %s absorbs all the damage.";
	{
		pattern = VSABSORBOTHEROTHER,
		map = {
			["source"] = 1,
			["spell"] = nil,
			["target"] = 2,
			["amount"] = nil,
		},
	},
	-- VSBLOCKOTHEROTHER
	-- 	enUS: "%s attacks. %s blocks.";
	{
		pattern = VSBLOCKOTHEROTHER,
		map = {
			["source"] = 1,
			["spell"] = nil,
			["target"] = 2,
			["amount"] = nil,
		},
	},
	-- VSDEFLECTOTHEROTHER
	-- 	enUS: "%s attacks. %s deflects.";
	{
		pattern = VSDEFLECTOTHEROTHER,
		map = {
			["source"] = 1,
			["spell"] = nil,
			["target"] = 2,
			["amount"] = nil,
		},
	},
	-- VSENVIRONMENTALDAMAGE_FALLING_OTHER
	-- 	enUS: "%s falls and loses %d health.";
	{
		pattern = VSENVIRONMENTALDAMAGE_FALLING_OTHER,
		map = {
			["source"] = 1,
			["spell"] = nil,
			["target"] = nil,
			["amount"] = 2,
		},
	},
	-- VSENVIRONMENTALDAMAGE_FIRE_OTHER
	--	enUS: "%s suffers %d points of fire damage.";
	{
		pattern = VSENVIRONMENTALDAMAGE_FIRE_OTHER,
		map = {
			["source"] = 1,
			["spell"] = nil,
			["target"] = nil,
			["amount"] = 2,
		},
	},
	-- VSENVIRONMENTALDAMAGE_LAVA_OTHER
	--	enUS: "%s loses %d health for swimming in lava.";
	{
		pattern = VSENVIRONMENTALDAMAGE_LAVA_OTHER,
		map = {
			["source"] = 1,
			["spell"] = nil,
			["target"] = nil,
			["amount"] = 2,
		},
	},
	-- VSENVIRONMENTALDAMAGE_SLIME_OTHER
	--	enUS: "%s loses %d health for swimming in slime.";
	{
		pattern = VSENVIRONMENTALDAMAGE_SLIME_OTHER,
		map = {
			["source"] = 1,
			["spell"] = nil,
			["target"] = nil,
			["amount"] = 2,
		},
	},
}

-- make it local for faster access
local messageMap = VanasKoS_Parser_MessageMap;

-- convert %s to (.+)
-- and changes the order in map if needed for other locales, thanks to ParserLib by Rophy
for k,v in pairs(messageMap) do
	local tmp = v.pattern:gsub("([%^%(%)%.%[%]%*%+%-%?])","%%%1");
	
	if(tmp:find("%$")) then
		-- order for map needs to be changed, b/c strings like
		-- HEALEDCRITOTHER = "Kritische Heilung: %2$s heilt %3$s um %4$d Punkte."; are found
		local order = { };
		local i = 1;
		for index in tmp:gmatch("%%(%d?)%$?[sd]") do
			order[i] = tonumber(index);
			i = i + 1;
		end
		for mapkey,mapvalue in pairs(v.map) do
			for orderkey, ordervalue in pairs(order) do
				-- order[1] = 3 ---- oldvalue = newvalue
				if(mapvalue == orderkey) then
					v.map[mapkey] = ordervalue;
				end
			end
		end
	end
	
	tmp = tmp:gsub("%%%d?%$?s", "(.+)")
	v.pattern = tmp:gsub("%%%d?%$?d", "(.+)")
end
